package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDEngine;
import com.sa.ibiz.demo.demo.service.TSSDEngineService;
import com.sa.ibiz.demo.demo.service.dto.TSSDEngineSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdengine")
public class TSSDEngineResource
{
	@Autowired
	private TSSDEngineService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDEngine> get(@Validated @PathVariable String id){
		TSSDEngine data=new TSSDEngine();
		data.setTssdengineid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务调度引擎[get]操作发生错误","TSSDEngine",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDEngine> getDraft(@Validated @RequestBody TSSDEngine data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度引擎[getDraft]操作发生错误","TSSDEngine","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDEngine> checkKey(@Validated @RequestBody TSSDEngine data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度引擎[checkKey]操作发生错误","TSSDEngine",data.getTssdengineid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<TSSDEngine> create(@Validated @RequestBody TSSDEngine data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度引擎[create]操作发生错误","TSSDEngine",data.getTssdengineid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDEngine> remove(@Validated @RequestBody TSSDEngine data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度引擎[remove]操作发生错误","TSSDEngine",data.getTssdengineid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDEngine> update(@Validated @RequestBody TSSDEngine data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务调度引擎[update]操作发生错误","TSSDEngine",data.getTssdengineid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDEngine>> searchDefaultPage(@Validated @RequestBody TSSDEngineSearchFilter filter){
		Page<TSSDEngine> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDEngine>> listDefault(@Validated @RequestBody TSSDEngineSearchFilter filter){
		List<TSSDEngine> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
